<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { Editor, EditorContent } from '@tiptap/vue-3'
import Bold from '@tiptap/extension-bold';
import Link from '@tiptap/extension-link';
import Italic from '@tiptap/extension-italic';
import Strike from '@tiptap/extension-strike';
import BulletList from '@tiptap/extension-bullet-list';
import OrderedList from '@tiptap/extension-ordered-list';
import Document from '@tiptap/extension-document';
import Text from '@tiptap/extension-text';
import ListItem from '@tiptap/extension-list-item';
import Paragraph from '@tiptap/extension-paragraph';
import TextStyle from '@tiptap/extension-text-style';
import { Color } from '@tiptap/extension-color';
import Highlight from '@tiptap/extension-highlight';
import { ref, watch, onMounted, onBeforeUnmount, computed } from 'vue';
import { useI18n } from 'vue-i18n';
import Modal from '@/components/general/Modal.vue';
import Input from '@/components/general/form/Input.vue';
import { validUrl } from '@/lib/utils';
//import Tooltip from '@/components/general/Tooltip.vue';
import ColorSwatch from '@/components/general/form/ColorSwatch.vue';
import Button from '@/components/general/Button.vue';

const { t } = useI18n();
const $t = t;

const props = defineProps({
    modelValue: { type: String, default: '', required: true },
    hideButtons: { type: Boolean, default: false },
    hideListButtons: { type: Boolean, default: false }
});

const emits = defineEmits<{
    (e: 'update:modelValue', value: string): void,
    (e: 'submit'): void,
    (e: 'cancel'): void
}>();

watch(() => props.modelValue, (modelValue) => {
    const isSame = editor.value!.getHTML() === modelValue;
    if (isSame) {
        return;
    }
    editor.value!.commands.setContent(modelValue, false);
});

const editor: any = ref(null);
const showURLModal = ref(false);
const url = ref('');

const handleSubmit = () => {
    emits('submit');
}

const handleCancel = () => {
    emits('cancel');
}

onMounted(() => {
    editor.value = new Editor({
        extensions: [
            Document,
            Text,
            Paragraph,
            Bold,
            Italic,
            Strike,
            //Underline,
            BulletList.configure({
                HTMLAttributes: {
                    class: "list-disc pl-4"
                }
            }),
            OrderedList.configure({
                HTMLAttributes: {
                    class: "list-decimal pl-4"
                }
            }),
            ListItem,
            TextStyle,
            Color,
            Link.configure({
                openOnClick: false,
                autolink: false,
                linkOnPaste: false,
                validate: href => /^https?:\/\//.test(href),
            }),
            Highlight.configure({ multicolor: true })
        ],
        content: props.modelValue,
        autofocus: 'end',
        onUpdate: () => {
            //const regex = /<a.*?href=['""](.+?)['""].*?>.+?<\/a>/g;
            const regex = /<a (?!.*class="custom-url-from-editor").*href=['""](?:mailto\:)*([^'""]+)['""].*>.*<\/a>/g;
            const replacePattern = "$1";
            emits('update:modelValue', editor.value.getHTML().replace(regex, replacePattern));
        },
    });
});
onBeforeUnmount(() => {
    editor.value.destroy()
});

const setLink = () => {
    const previousUrl = editor.value.getAttributes('link').href;
    url.value = previousUrl;
    showURLModal.value = true;
};

const handleSubmitUrl = () => {
    // cancelled
    if (url.value === null) {
        return
    }

    // empty
    if (url.value === '') {
        editor.value
            .chain()
            .focus()
            .extendMarkRange('link')
            .unsetLink()
            .run()

        return
    }

    // update link
    editor.value
        .chain()
        .focus()
        .extendMarkRange('link')
        .setLink({ href: url.value, class: "custom-url-from-editor" })
        .run()

    handleCancelUrl();
};

const handleCancelUrl = () => {
    showURLModal.value = false;
    url.value = "";
};

const isUrlValid = computed(() => {
    return validUrl(url.value);
});

</script>
<template>
    <div class="flex flex-col items-stretch h-full">
        <div class="py-1.5 flex flex-row gap-4 bg-transparent border-b border-b-gray-300 mx-1.5" v-if="editor">
            <div class="bg-gray-100 rounded-md w-fit p-1 flex flex-row h-10 ">
                <Tooltip :tooltip="$t('contentPage.textEditor.bold')"><button
                        class="p-1 size-8 hover:bg-gray-200 rounded-md text-gray-700"
                        @click="editor.chain().focus().toggleBold().run()"
                        :class="{ 'bg-gray-300 hover:bg-gray-400': editor.isActive('bold') }"><i
                            class="ri-bold"></i></button></Tooltip>
                <Tooltip :tooltip="$t('contentPage.textEditor.italic')"><button
                        class="p-1 size-8 hover:bg-gray-200 rounded-md text-gray-700"
                        @click="editor.chain().focus().toggleItalic().run()"
                        :class="{ 'bg-gray-300 hover:bg-gray-400': editor.isActive('italic') }"><i
                            class="ri-italic"></i></button></Tooltip>
                <Tooltip :tooltip="$t('contentPage.textEditor.strikethrough')"><button
                        class="p-1 size-8 hover:bg-gray-200 rounded-md text-gray-700"
                        @click="editor.chain().focus().toggleStrike().run()"
                        :class="{ 'bg-gray-300 hover:bg-gray-400': editor.isActive('strike') }"><i
                            class="ri-strikethrough"></i></button>
                </Tooltip>
            </div>
            <div class="bg-gray-100 rounded-md w-fit p-1 flex flex-row h-10" v-if="!hideListButtons">
                <Tooltip :tooltip="$t('contentPage.textEditor.bulletlist')"><button
                        class="p-1 size-8 hover:bg-gray-200 rounded-md text-gray-700"
                        @click="editor.chain().focus().toggleBulletList().run()"
                        :class="{ 'bg-gray-300 hover:bg-gray-400': editor.isActive('bulletList') }"><i
                            class="ri-list-unordered"></i></button></Tooltip>
                <Tooltip :tooltip="$t('contentPage.textEditor.orderedList')"><button
                        class="p-1 size-8 hover:bg-gray-200 rounded-md text-gray-700"
                        @click="editor.chain().focus().toggleOrderedList().run()"
                        :class="{ 'bg-gray-300 hover:bg-gray-400': editor.isActive('orderedList') }"><i
                            class="ri-list-ordered"></i></button></Tooltip>
            </div>
            <div class="bg-gray-100 rounded-md w-fit p-1 flex flex-row h-10">
                <Tooltip :tooltip="$t('contentPage.textEditor.color')">
                    <button class="p-1 size-8 hover:bg-gray-200 rounded-md">
                        <ColorSwatch v-model="editor.getAttributes('textStyle').color"
                            @change="(e: any) => editor.chain().focus().setColor(e.target.value).run()" hideIcon />
                    </button>
                </Tooltip>
                <Tooltip :tooltip="$t('contentPage.textEditor.colorReset')">
                    <button class="p-1 size-8 hover:bg-gray-200 rounded-md" @click="editor.chain().focus().setColor('#374151').run">
                        <i class="ri-blur-off-line"></i>
                    </button>
                </Tooltip>
                <Tooltip :tooltip="$t('contentPage.textEditor.highlight')">
                    <button class="p-1 size-8 hover:bg-gray-200 rounded-md"
                        @click="editor.chain().focus().toggleHighlight({ color: '#ffc078' }).run()"
                        :class="{ 'bg-gray-300 hover:bg-gray-400': editor.isActive('highlight', { color: '#ffc078' }) }">
                        <span class="border-b-4 border-[#ffc078]"><i class="ri-mark-pen-line"></i></span>
                    </button>
                </Tooltip>
            </div>
            <div class="bg-gray-100 rounded-md w-fit p-1 flex flex-row h-10">
                <Tooltip :tooltip="$t('contentPage.textEditor.link')">
                    <button class="p-1 size-8 hover:bg-gray-200 rounded-md" @click="setLink"
                        :class="{ 'bg-gray-300 hover:bg-gray-400': editor.isActive('link') }"><i
                            class="ri-link"></i></button>
                </Tooltip>
            </div>
        </div>
        <div class="grow textarea">
            <EditorContent :editor="editor" />
        </div>
        <div class="p-1" v-if="!hideButtons">
            <div class="flex flex-row items-stretch w-full">
                <div class="w-fit">
                    <Tooltip :tooltip="$t('general.buttons.send')">
                        <Button variant="confirm" size="small" @click="handleSubmit()"><i
                                class="ri-check-line"></i></Button>
                    </Tooltip>
                </div>
                <div class="grow"></div>
                <div class="w-fit self-end">
                    <Tooltip :tooltip="$t('general.buttons.cancel')">
                        <Button variant="cancel" size="small" @click="handleCancel()"><i
                                class="ri-close-line"></i></Button>
                    </Tooltip>
                </div>
            </div>
        </div>
        <Modal v-if="showURLModal" @submit="handleSubmitUrl" @cancel="handleCancelUrl"
            :labelCancel="$t('general.buttons.cancel')" :labelSubmit="$t('general.buttons.send')"
            :disableSubmit="!isUrlValid">
            <Input :label="$t('contentPage.textEditor.link')"
                :placeholder="$t('contentPage.textEditor.link') + ' (https://...)'" v-model="url" type="text"
                :errorText="isUrlValid ? undefined : $t('contentPage.textEditor.invalidLink')" />
        </Modal>
    </div>
</template>
<style scoped>
*>>>.ProseMirror {
    resize: none;
    border: none;
    max-height: 75px;
    padding: 10px;
    overflow: auto;
}

*>>>.ProseMirror:focus {
    outline: none;
}
</style>